## luanti 5.13.0%2Bdfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
if(POLICY CMP0177)
    cmake_policy(SET CMP0177 NEW)
endif()

# This can be read from ${PROJECT_NAME} after project() is called
project(luanti)
set(PROJECT_NAME_CAPITALIZED "Luanti")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)
set(GCC_MINIMUM_VERSION "7.5")
set(CLANG_MINIMUM_VERSION "7.0.1")

# You should not need to edit these manually, use util/bump_version.sh
set(VERSION_MAJOR 5)
set(VERSION_MINOR 13)
set(VERSION_PATCH 0)
set(VERSION_EXTRA "" CACHE STRING "Stuff to append to version string")

# Change to false for releases
set(DEVELOPMENT_BUILD FALSE)

set(VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
if(VERSION_EXTRA)
	set(VERSION_STRING "${VERSION_STRING}-${VERSION_EXTRA}")
elseif(DEVELOPMENT_BUILD)
	set(VERSION_STRING "${VERSION_STRING}-dev")
endif()

if (CMAKE_BUILD_TYPE STREQUAL Debug)
	# Append "-debug" to version string
	set(VERSION_STRING "${VERSION_STRING}-debug")
endif()

# Configuration options
set(BUILD_CLIENT TRUE CACHE BOOL "Build client")
set(BUILD_SERVER FALSE CACHE BOOL "Build server")
set(BUILD_UNITTESTS TRUE CACHE BOOL "Build unittests")
set(BUILD_BENCHMARKS FALSE CACHE BOOL "Build benchmarks")
set(BUILD_DOCUMENTATION TRUE CACHE BOOL "Build documentation")

set(DEFAULT_ENABLE_LTO TRUE)
# by default don't enable on Debug builds to get faster builds
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(DEFAULT_ENABLE_LTO FALSE)
endif()
#### LTO testing list ####
# - Linux: seems to work always
# - win32/msvc: works
# - win32/gcc: fails to link
# - win32/clang: works
# - macOS on x86: seems to be fine
# - macOS on ARM: crashes, see <https://github.com/luanti-org/luanti/issues/14397>
# Note: since CMake has no easy architecture detection disabling for Mac entirely
#### ####
if((WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU") OR APPLE)
	set(DEFAULT_ENABLE_LTO FALSE)
endif()
set(ENABLE_LTO ${DEFAULT_ENABLE_LTO} CACHE BOOL "Use Link Time Optimization")

set(BUILD_WITH_TRACY FALSE CACHE BOOL
	"Fetch and build with the Tracy profiler client")
set(FETCH_TRACY_GIT_TAG "master" CACHE STRING
	"Git tag for fetching Tracy client. Match with your server (gui) version")

set(DEFAULT_RUN_IN_PLACE FALSE)
if(WIN32)
	set(DEFAULT_RUN_IN_PLACE TRUE)
endif()
set(RUN_IN_PLACE ${DEFAULT_RUN_IN_PLACE} CACHE BOOL
	"Run directly in source directory structure")

message(STATUS "*** Will build version ${VERSION_STRING} ***")
message(STATUS "BUILD_CLIENT: " ${BUILD_CLIENT})
message(STATUS "BUILD_SERVER: " ${BUILD_SERVER})
message(STATUS "BUILD_UNITTESTS: " ${BUILD_UNITTESTS})
message(STATUS "BUILD_BENCHMARKS: " ${BUILD_BENCHMARKS})
message(STATUS "BUILD_DOCUMENTATION: " ${BUILD_DOCUMENTATION})
message(STATUS "RUN_IN_PLACE: " ${RUN_IN_PLACE})

set(WARN_ALL TRUE CACHE BOOL "Enable -Wall for Release build")

if(NOT CMAKE_BUILD_TYPE)
	# Default to release
	set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type: Debug or Release" FORCE)
endif()

set(ENABLE_UPDATE_CHECKER (NOT ${DEVELOPMENT_BUILD}) CACHE BOOL
	"Whether to enable update checks by default")

# Included stuff
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Load default options for Android
if(ANDROID)
	cmake_minimum_required(VERSION 3.20)
	include(AndroidLibs)
endif()


if(TRUE)
	message(STATUS "Using imported IrrlichtMt at subdirectory 'irr'")
	if(BUILD_CLIENT)
		add_subdirectory(irr EXCLUDE_FROM_ALL)

		if(NOT TARGET IrrlichtMt)
			message(FATAL_ERROR "IrrlichtMt project is missing a CMake target?!")
		endif()
	else()
		add_library(IrrlichtMt::IrrlichtMt INTERFACE IMPORTED)
		set_target_properties(IrrlichtMt::IrrlichtMt PROPERTIES
			INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/irr/include")
	endif()
endif()

if (ENABLE_LTO OR CMAKE_INTERPROCEDURAL_OPTIMIZATION)
	include(CheckIPOSupported)
	check_ipo_supported(RESULT lto_supported OUTPUT lto_output)
	if(lto_supported)
		set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
		message(STATUS "LTO/IPO is enabled")
	else()
		set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
		message(STATUS "LTO/IPO was requested but is not supported by the compiler: ${lto_output}")
	endif()
else()
	message(STATUS "LTO/IPO is not enabled")
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
	if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "${GCC_MINIMUM_VERSION}")
		message(FATAL_ERROR "Insufficient gcc version, found ${CMAKE_CXX_COMPILER_VERSION}. "
			"Version ${GCC_MINIMUM_VERSION} or higher is required.")
	endif()
elseif(CMAKE_CXX_COMPILER_ID MATCHES "(Apple)?Clang")
	if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "${CLANG_MINIMUM_VERSION}")
		message(FATAL_ERROR "Insufficient clang version, found ${CMAKE_CXX_COMPILER_VERSION}. "
			"Version ${CLANG_MINIMUM_VERSION} or higher is required.")
	endif()
endif()

# Installation

if(WIN32)
	set(SHAREDIR ".")
	set(BINDIR "bin")
	set(DOCDIR "doc")
	set(EXAMPLE_CONF_DIR ".")
	set(LOCALEDIR "locale")
elseif(APPLE)
	set(BUNDLE_NAME ${PROJECT_NAME}.app)
	set(BUNDLE_PATH "${BUNDLE_NAME}")
	set(BINDIR ${BUNDLE_NAME}/Contents/MacOS)
	set(SHAREDIR ${BUNDLE_NAME}/Contents/Resources)
	set(DOCDIR "${SHAREDIR}/${PROJECT_NAME}")
	set(EXAMPLE_CONF_DIR ${DOCDIR})
	set(LOCALEDIR "${SHAREDIR}/locale")
elseif(UNIX) # Linux, BSD etc
	if(RUN_IN_PLACE)
		set(SHAREDIR ".")
		set(BINDIR "bin")
		set(DOCDIR "doc")
		set(EXAMPLE_CONF_DIR ".")
		set(MANDIR "unix/man")
		set(XDG_APPS_DIR "unix/applications")
		set(METAINFODIR "unix/metainfo")
		set(ICONDIR "unix/icons")
		set(LOCALEDIR "locale")
	else()
		include(GNUInstallDirs)
		set(SHAREDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}")
		set(BINDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}")
		set(DOCDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DOCDIR}")
		set(MANDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_MANDIR}")
		set(EXAMPLE_CONF_DIR ${DOCDIR})
		set(XDG_APPS_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/applications")
		set(METAINFODIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/metainfo")
		set(ICONDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/icons")
		set(LOCALEDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LOCALEDIR}")
	endif()
endif()

set(CUSTOM_SHAREDIR "" CACHE STRING "Directory to install data files into")
if(NOT CUSTOM_SHAREDIR STREQUAL "")
	set(SHAREDIR "${CUSTOM_SHAREDIR}")
	message(STATUS "Using SHAREDIR=${SHAREDIR}")
endif()

set(CUSTOM_BINDIR "" CACHE STRING "Directory to install binaries into")
if(NOT CUSTOM_BINDIR STREQUAL "")
	set(BINDIR "${CUSTOM_BINDIR}")
	message(STATUS "Using BINDIR=${BINDIR}")
endif()

set(CUSTOM_DOCDIR "" CACHE STRING "Directory to install documentation into")
if(NOT CUSTOM_DOCDIR STREQUAL "")
	set(DOCDIR "${CUSTOM_DOCDIR}")
	if(NOT RUN_IN_PLACE)
		set(EXAMPLE_CONF_DIR ${DOCDIR})
	endif()
	message(STATUS "Using DOCDIR=${DOCDIR}")
endif()

set(CUSTOM_MANDIR "" CACHE STRING "Directory to install manpages into")
if(NOT CUSTOM_MANDIR STREQUAL "")
	set(MANDIR "${CUSTOM_MANDIR}")
	message(STATUS "Using MANDIR=${MANDIR}")
endif()

set(CUSTOM_EXAMPLE_CONF_DIR "" CACHE STRING "Directory to install example config file into")
if(NOT CUSTOM_EXAMPLE_CONF_DIR STREQUAL "")
	set(EXAMPLE_CONF_DIR "${CUSTOM_EXAMPLE_CONF_DIR}")
	message(STATUS "Using EXAMPLE_CONF_DIR=${EXAMPLE_CONF_DIR}")
endif()

set(CUSTOM_XDG_APPS_DIR "" CACHE STRING "Directory to install .desktop files into")
if(NOT CUSTOM_XDG_APPS_DIR STREQUAL "")
	set(XDG_APPS_DIR "${CUSTOM_XDG_APPS_DIR}")
	message(STATUS "Using XDG_APPS_DIR=${XDG_APPS_DIR}")
endif()

set(CUSTOM_ICONDIR "" CACHE STRING "Directory to install icons into")
if(NOT CUSTOM_ICONDIR STREQUAL "")
	set(ICONDIR "${CUSTOM_ICONDIR}")
	message(STATUS "Using ICONDIR=${ICONDIR}")
endif()

set(CUSTOM_LOCALEDIR "" CACHE STRING "Directory to install l10n files into")
if(NOT CUSTOM_LOCALEDIR STREQUAL "")
	set(LOCALEDIR "${CUSTOM_LOCALEDIR}")
	message(STATUS "Using LOCALEDIR=${LOCALEDIR}")
endif()


install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/builtin" DESTINATION "${SHAREDIR}")
if(RUN_IN_PLACE)
	install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/mods/mods_here.txt" DESTINATION "${SHAREDIR}/mods")
	install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/textures/texture_packs_here.txt" DESTINATION "${SHAREDIR}/textures")
endif()

set(INSTALL_DEVTEST FALSE CACHE BOOL "Install Development Test")

if(INSTALL_DEVTEST)
	install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/games/devtest" DESTINATION "${SHAREDIR}/games/"
		PATTERN ".git*" EXCLUDE )
endif()

if(BUILD_CLIENT)
	install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/client/shaders" DESTINATION "${SHAREDIR}/client")
	install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/textures/base/pack" DESTINATION "${SHAREDIR}/textures/base")
	if(RUN_IN_PLACE)
		install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/clientmods" DESTINATION "${SHAREDIR}")
		install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/client/serverlist" DESTINATION "${SHAREDIR}/client")
	endif()
endif()

install(FILES "README.md" DESTINATION "${DOCDIR}" COMPONENT "Docs")
install(FILES "doc/lua_api.md" DESTINATION "${DOCDIR}" COMPONENT "Docs")
install(FILES "doc/client_lua_api.md" DESTINATION "${DOCDIR}" COMPONENT "Docs")
install(FILES "doc/menu_lua_api.md" DESTINATION "${DOCDIR}" COMPONENT "Docs")
install(FILES "doc/texture_packs.md" DESTINATION "${DOCDIR}" COMPONENT "Docs")
install(FILES "doc/world_format.md" DESTINATION "${DOCDIR}" COMPONENT "Docs")
install(FILES "minetest.conf.example" DESTINATION "${EXAMPLE_CONF_DIR}")

if(UNIX AND NOT APPLE)
	install(FILES "doc/luanti.6" "doc/luantiserver.6" DESTINATION "${MANDIR}/man6")
	install(FILES "misc/org.luanti.luanti.desktop" DESTINATION "${XDG_APPS_DIR}")
	install(FILES "misc/org.luanti.luanti.metainfo.xml" DESTINATION "${METAINFODIR}")
	install(FILES "misc/luanti.svg" DESTINATION "${ICONDIR}/hicolor/scalable/apps")
	install(FILES "misc/luanti-xorg-icon-128.png"
		DESTINATION "${ICONDIR}/hicolor/128x128/apps"
		RENAME "luanti.png")
endif()

if(APPLE)
	install(FILES "misc/luanti-icon.icns" DESTINATION "${SHAREDIR}")
	install(FILES "${CMAKE_BINARY_DIR}/Info.plist" DESTINATION "${BUNDLE_PATH}/Contents")
endif()

if(CMAKE_GENERATOR STREQUAL "Xcode")
	set(client_RESOURCES "${CMAKE_SOURCE_DIR}/misc/luanti-icon.icns")
endif()

# Library pack
find_package(GMP REQUIRED)
find_package(Json 1.0.0 REQUIRED)
find_package(Lua REQUIRED)
if(NOT USE_LUAJIT)
	add_subdirectory(lib/bitop)
endif()
add_subdirectory(lib/sha256)

if(BUILD_UNITTESTS OR BUILD_BENCHMARKS)
	add_subdirectory(lib/catch2)
endif()

add_subdirectory(lib/tiniergltf)

# Subdirectories
# Be sure to add all relevant definitions above this
add_subdirectory(src)

# CPack

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A free open-source voxel game engine with easy modding and game creation.")
set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
set(CPACK_PACKAGE_VENDOR "celeron55")
set(CPACK_PACKAGE_CONTACT "Perttu Ahola <celeron55@gmail.com>")

include(CPackComponent)

cpack_add_component(Docs
	DISPLAY_NAME "Documentation"
	DESCRIPTION "Documentation about ${PROJECT_NAME_CAPITALIZED} and ${PROJECT_NAME_CAPITALIZED} modding"
)

if(WIN32)
	# Include all dynamically linked runtime libraries such as MSVCRxxx.dll
	include(InstallRequiredSystemLibraries)

	if(RUN_IN_PLACE)
		if(CMAKE_SIZEOF_VOID_P EQUAL 8)
			set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION_STRING}-win64")
		else()
			set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION_STRING}-win32")
		endif()

		set(CPACK_GENERATOR ZIP)

	else()
		set(CPACK_GENERATOR WIX)
		set(CPACK_PACKAGE_NAME "${PROJECT_NAME_CAPITALIZED}")
		set(CPACK_PACKAGE_INSTALL_DIRECTORY ".")
		set(CPACK_PACKAGE_EXECUTABLES ${PROJECT_NAME} "${PROJECT_NAME_CAPITALIZED}")
		set(CPACK_CREATE_DESKTOP_LINKS ${PROJECT_NAME})
		set(CPACK_PACKAGING_INSTALL_PREFIX "/${PROJECT_NAME_CAPITALIZED}")

		set(CPACK_WIX_PRODUCT_ICON "${CMAKE_CURRENT_SOURCE_DIR}/misc/luanti-icon.ico")
		# Supported languages can be found at

=== irr/src/CMakeLists.txt ===
set(DEFAULT_SDL2 ON)

option(USE_SDL2 "Use the SDL2 backend" ${DEFAULT_SDL2})

option(USE_SDL2_STATIC "Link with SDL2 static libraries" FALSE)

# Compiler flags

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
	add_compile_definitions(_DEBUG)
endif()
set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)

if(CMAKE_CXX_COMPILER_ID MATCHES "^(GNU|Clang|AppleClang)$")
	set(CMAKE_CXX_FLAGS_RELEASE "-O3")
	set(CMAKE_CXX_FLAGS_DEBUG "-g")

	add_compile_options(-Wall -pipe)

	# Enable SSE for floating point math on 32-bit x86 by default
	# reasoning see minetest issue #11810 and https://gcc.gnu.org/wiki/FloatingPointMath
	if(CMAKE_SIZEOF_VOID_P EQUAL 4)
		include(CheckCXXSourceCompiles)
		check_cxx_source_compiles("#ifndef __i686__\n#error\n#endif\nint main(){}" IS_I686)
		if(IS_I686)
			message(STATUS "Detected Intel x86: using SSE instead of x87 FPU")
			add_compile_options(-mfpmath=sse -msse)
		endif()
	endif()

elseif(MSVC)
	string(APPEND CMAKE_CXX_STANDARD_LIBRARIES " msvcrt.lib") # ???? fuck off

	add_compile_definitions(
		# Suppress some useless warnings
		_CRT_SECURE_NO_DEPRECATE
		# Get M_PI to work
		_USE_MATH_DEFINES
		# Don't define min/max macros in minwindef.h
		NOMINMAX
	)

	add_compile_options(/Zl)

	# Enable SSE for floating point math on 32-bit x86 by default
	# reasoning see minetest issue #11810 and https://gcc.gnu.org/wiki/FloatingPointMath
	if(CMAKE_SIZEOF_VOID_P EQUAL 4)
		add_compile_options(/arch:SSE)
	endif()
endif()

# Platform-independent configuration (hard-coded currently)
add_compile_definitions(IRR_ENABLE_BUILTIN_FONT)

# Platform-specific configuration

if(CMAKE_SYSTEM_NAME STREQUAL "SunOS")
	set(SOLARIS TRUE)
endif()

# Device

if(WIN32)
	add_compile_definitions(_IRR_WINDOWS_ _IRR_WINDOWS_API_)
	set(DEVICE "WINDOWS")
elseif(APPLE)
	add_compile_definitions(_IRR_OSX_PLATFORM_)
	set(DEVICE "OSX")
elseif(ANDROID)
	add_compile_definitions(_IRR_ANDROID_PLATFORM_)
	if(NOT USE_SDL2)
		message(FATAL_ERROR "The Android build requires SDL2")
	endif()
elseif(EMSCRIPTEN)
	add_compile_definitions(_IRR_EMSCRIPTEN_PLATFORM_ _IRR_COMPILE_WITH_EGL_MANAGER_)
	set(LINUX_PLATFORM TRUE)
	set(DEVICE "SDL")
elseif(SOLARIS)
	add_compile_definitions(_IRR_SOLARIS_PLATFORM_ _IRR_POSIX_API_)
	set(DEVICE "X11")
else()
	add_compile_definitions(_IRR_POSIX_API_)
	set(LINUX_PLATFORM TRUE)
	set(DEVICE "X11")
endif()

if(LINUX_PLATFORM)
	add_compile_definitions(_IRR_LINUX_PLATFORM_)
endif()

if(MSVC)
	add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
endif()

if(USE_SDL2)
	set(DEVICE "SDL")
elseif(DEVICE STREQUAL "SDL")
	message(FATAL_ERROR "SDL was used but not enabled?!")
endif()

add_compile_definitions("_IRR_COMPILE_WITH_${DEVICE}_DEVICE_")

# X11

if(DEVICE STREQUAL "X11")
	option(USE_X11 "Use X11" TRUE)
else()
	set(USE_X11 FALSE)
endif()

if(LINUX_PLATFORM AND USE_X11)
	option(USE_XINPUT2 "Use XInput2" TRUE)
	option(USE_XCURSOR "Use XCursor" FALSE)
else()
	set(USE_XINPUT2 FALSE)
	set(USE_XCURSOR FALSE)
endif()

# Joystick

if(NOT (BSD OR SOLARIS OR EMSCRIPTEN))
	add_compile_definitions(_IRR_COMPILE_WITH_JOYSTICK_EVENTS_)
endif()

# OpenGL

if(USE_SDL2)
	if(NOT ANDROID)
		set(DEFAULT_OPENGL3 TRUE)
	endif()
else()
	set(DEFAULT_OPENGL3 FALSE)
endif()
option(ENABLE_OPENGL3 "Enable OpenGL 3+" ${DEFAULT_OPENGL3})

if(ANDROID OR EMSCRIPTEN)
	set(ENABLE_OPENGL FALSE)
else()
	option(ENABLE_OPENGL "Enable OpenGL" TRUE)
endif()

if(APPLE)
	set(ENABLE_GLES2 FALSE)
	set(ENABLE_WEBGL1 FALSE)
else()
	if(ANDROID OR EMSCRIPTEN)
		set(DEFAULT_GLES2 TRUE)
	endif()
	if(EMSCRIPTEN)
		set(DEFAULT_WEBGL1 TRUE)
	endif()
	option(ENABLE_GLES2 "Enable OpenGL ES 2+" ${DEFAULT_GLES2})
	#option(ENABLE_WEBGL1 "Enable WebGL (requires GLES2)" ${DEFAULT_WEBGL1})
	set(ENABLE_WEBGL1 FALSE) # not working currently
	if(ENABLE_WEBGL1)
		set(ENABLE_GLES2 TRUE)
	endif()
endif()

if(ENABLE_OPENGL OR (ENABLE_OPENGL3 AND NOT USE_SDL2))
	if(ENABLE_OPENGL)
		add_compile_definitions(_IRR_COMPILE_WITH_OPENGL_)
		set(OPENGL_DIRECT_LINK TRUE) # driver relies on this
	endif()
	if(DEVICE STREQUAL "WINDOWS")
		add_compile_definitions(_IRR_COMPILE_WITH_WGL_MANAGER_)
	elseif(DEVICE STREQUAL "X11")
		add_compile_definitions(_IRR_COMPILE_WITH_GLX_MANAGER_)
	elseif(DEVICE STREQUAL "OSX")
		add_compile_definitions(_IRR_COMPILE_WITH_NSOGL_MANAGER_)
	endif()
endif()

if(ENABLE_OPENGL3)
	if(DEVICE STREQUAL "WINDOWS")
		# supported
	elseif(DEVICE STREQUAL "X11")
		# supported
	elseif (NOT USE_SDL2)
		message(FATAL_ERROR "OpenGL 3 driver requires SDL2")
	endif()
endif()

if(ENABLE_GLES2)
	add_compile_definitions(_IRR_COMPILE_WITH_OGLES2_)
	if(DEVICE MATCHES "^(WINDOWS|X11)$" OR EMSCRIPTEN)
		add_compile_definitions(_IRR_COMPILE_WITH_EGL_MANAGER_)
	endif()
endif()

if(ENABLE_WEBGL1)
	add_compile_definitions(_IRR_COMPILE_WITH_WEBGL1_)
endif()

# Misc

include(TestBigEndian)
TEST_BIG_ENDIAN(BIG_ENDIAN)
if(BIG_ENDIAN)
	add_compile_definitions(__BIG_ENDIAN__)
endif()

# Configuration report

message(STATUS "Device: ${DEVICE}")
message(STATUS "OpenGL: ${ENABLE_OPENGL}")
message(STATUS "OpenGL 3: ${ENABLE_OPENGL3}")
if (ENABLE_GLES2)
	message(STATUS "OpenGL ES 2: ON (unified)")
else()
	message(STATUS "OpenGL ES 2: OFF")
endif()
#message(STATUS "WebGL: ${ENABLE_WEBGL1}")

# Required libs

include(CheckCXXSourceCompiles)

find_package(ZLIB REQUIRED)
find_package(JPEG REQUIRED)
find_package(PNG REQUIRED)

if(ENABLE_GLES2)
	find_package(OpenGLES2 REQUIRED)
endif()
if(ENABLE_OPENGL)
	find_package(OpenGL REQUIRED)
endif()
set(USE_SDL2_SHARED FALSE)
if(USE_SDL2)
	if(NOT USE_SDL2_STATIC)
		set(USE_SDL2_SHARED TRUE)
	endif()
	if(NOT ANDROID)
		find_package(SDL2 REQUIRED)
	else()
		# provided by AndroidLibs.cmake
	endif()
	message(STATUS "Found SDL2: ${SDL2_LIBRARIES}")

	# unfortunately older SDL does not provide its version to cmake, so check header.
	set(CMAKE_REQUIRED_INCLUDES ${SDL2_INCLUDE_DIRS})
	unset(CHECK_SDL_VERSION CACHE)
	check_cxx_source_compiles("#include <SDL_version.h>\n\
#if !SDL_VERSION_ATLEAST(2, 0, 10)\n\
#error\n\
#endif\n\
int main() {}" CHECK_SDL_VERSION)
	if(NOT CHECK_SDL_VERSION)
		message(FATAL_ERROR "SDL2 is too old, required is at least 2.0.10!")
	endif()

	# ...no target either.
	if(NOT TARGET SDL2::SDL2)
		add_library(SDL2::SDL2 SHARED IMPORTED)
		set_target_properties(SDL2::SDL2 PROPERTIES
			IMPORTED_LOCATION "${SDL2_LIBRARIES}")
	endif()
endif()

# More special config

if(ENABLE_OPENGL AND DEVICE STREQUAL "SDL")
	# The legacy GL driver requires some symbols from GL 4.5 to compile,
	# which SDL only provides since 2.26.0 (Nov 2022).
	# We have a fallback in case this isn't satisfied so test for it.
	set(CMAKE_REQUIRED_INCLUDES ${SDL2_INCLUDE_DIRS})
	unset(CHECK_GL_VERSION_4_5 CACHE)
	check_cxx_source_compiles("#include <SDL_opengl.h>\n\
#ifndef GL_VERSION_4_5\n\
#error\n\
#endif\n\
int main() {}" CHECK_GL_VERSION_4_5)
	if(CHECK_GL_VERSION_4_5)
		add_compile_definitions(IRR_PREFER_SDL_GL_HEADER)
	endif()
endif()

# Platform-specific libs

if(ANDROID)
	enable_language(C)
elseif(APPLE)
	find_library(COCOA_LIB Cocoa REQUIRED)
	find_library(IOKIT_LIB IOKit REQUIRED)

	add_compile_definitions(GL_SILENCE_DEPRECATION)
elseif(NOT USE_SDL2)
	# Unix probably
	find_package(X11 REQUIRED)
	if(USE_XINPUT2 AND NOT X11_Xi_FOUND)
		message(FATAL_ERROR "XInput not found")
	endif()
endif()

set(link_includes
	"${PROJECT_SOURCE_DIR}/include"
	"${CMAKE_CURRENT_SOURCE_DIR}"

	"${ZLIB_INCLUDE_DIR}"
	"${JPEG_INCLUDE_DIR}"
	"${PNG_INCLUDE_DIR}"
	"$<$<BOOL:${USE_SDL2}>:${SDL2_INCLUDE_DIRS}>"

	${OPENGL_INCLUDE_DIR}
	${OPENGLES2_INCLUDE_DIR}
	${EGL_INCLUDE_DIR}

	"$<$<BOOL:${USE_X11}>:${X11_INCLUDE_DIR}>"
)

# Source files

set(IRRMESHLOADER
	CB3DMeshFileLoader.h
	CGLTFMeshFileLoader.h
	COBJMeshFileLoader.h
	CXMeshFileLoader.h

	CB3DMeshFileLoader.cpp
	CGLTFMeshFileLoader.cpp
	COBJMeshFileLoader.cpp
	CXMeshFileLoader.cpp
)

add_library(IRRMESHOBJ OBJECT
	CMeshSceneNode.h
	CAnimatedMeshSceneNode.h

	SkinnedMesh.cpp
	CMeshSceneNode.cpp
	CAnimatedMeshSceneNode.cpp

	${IRRMESHLOADER}
)

target_link_libraries(IRRMESHOBJ PUBLIC tiniergltf::tiniergltf)

set(IRRDRVROBJ
	CNullDriver.h
	CGLXManager.h
	CWGLManager.h
	CEGLManager.h
	CSDLManager.h

	CNullDriver.cpp
	CGLXManager.cpp
	CWGLManager.cpp
	CEGLManager.cpp
	CSDLManager.cpp
	mt_opengl_loader.cpp
)

# the two legacy drivers

if(ENABLE_OPENGL)
	set(IRRDRVROBJ
		${IRRDRVROBJ}
		COpenGLCacheHandler.h
		COpenGLDriver.h
		COpenGLSLMaterialRenderer.h
		COpenGLExtensionHandler.h

		COpenGLCacheHandler.cpp
		COpenGLDriver.cpp
		COpenGLSLMaterialRenderer.cpp
		COpenGLExtensionHandler.cpp
	)
endif()

# the unified drivers

if(ENABLE_OPENGL3 OR ENABLE_GLES2)
	file(GLOB IRRDRVR_HDRS "${CMAKE_CURRENT_SOURCE_DIR}/OpenGL/*.h")

	set(IRRDRVROBJ
		${IRRDRVROBJ}
		${IRRDRVR_HDRS}
		OpenGL/Driver.cpp
		OpenGL/ExtensionHandler.cpp
		OpenGL/FixedPipelineRenderer.cpp
		OpenGL/MaterialRenderer.cpp
		OpenGL/Renderer2D.cpp
		OpenGL/VBO.cpp
	)
endif()

if(ENABLE_OPENGL3)
	set(IRRDRVROBJ
		${IRRDRVROBJ}
		OpenGL3/DriverGL3.h
		OpenGL3/DriverGL3.cpp
	)
endif()

if(ENABLE_GLES2)
	set(IRRDRVROBJ
		${IRRDRVROBJ}
		OpenGLES2/DriverGLES2.h
		OpenGLES2/DriverGLES2.cpp
	)
endif()

set(IRRIMAGEOBJ
	CColorConverter.h
	CImage.h
	CImageLoaderJPG.h
	CImageLoaderPNG.h
	CImageLoaderTGA.h
	CImageWriterJPG.h
	CImageWriterPNG.h

	CColorConverter.cpp
	CImage.cpp
	CImageLoaderJPG.cpp
	CImageLoaderPNG.cpp
	CImageLoaderTGA.cpp
	CImageWriterJPG.cpp
	CImageWriterPNG.cpp
)

add_library(IRRVIDEOOBJ OBJECT
	CFPSCounter.h
	CFPSCounter.cpp
	${IRRDRVROBJ}
	${IRRIMAGEOBJ}
)

add_library(IRRIOOBJ OBJECT
	CFileList.h
	CFileSystem.h
	CLimitReadFile.h
	CMemoryFile.h
	CReadFile.h
	CWriteFile.h
	CZipReader.h

	CFileList.cpp
	CFileSystem.cpp
	CLimitReadFile.cpp
	CMemoryFile.cpp
	CReadFile.cpp
	CWriteFile.cpp
	CZipReader.cpp
)

add_library(IRROTHEROBJ OBJECT
	CIrrDeviceSDL.h
	CIrrDeviceLinux.h
	CIrrDeviceStub.h
	CIrrDeviceWin32.h
	CLogger.h
	COSOperator.h
	os.h

	CIrrDeviceSDL.cpp
	CIrrDeviceLinux.cpp
	CIrrDeviceStub.cpp
	CIrrDeviceWin32.cpp
	CLogger.cpp
	COSOperator.cpp
	Irrlicht.cpp
	os.cpp
)

if(ENABLE_OPENGL3)
	target_compile_definitions(IRROTHEROBJ PRIVATE ENABLE_OPENGL3)
endif()

if(APPLE)
	# Build all IRROTHEROBJ sources as objc++, including the .cpp's
	set_target_properties(IRROTHEROBJ PROPERTIES COMPILE_OPTIONS "-xobjective-c++")
	target_sources(IRROTHEROBJ PRIVATE
		CIrrDeviceOSX.mm
		CNSOGLManager.mm
	)
endif()

if(USE_X11)
	target_compile_definitions(IRROTHEROBJ PRIVATE _IRR_COMPILE_WITH_X11_)
endif()

if(USE_XINPUT2)
	target_compile_definitions(IRROTHEROBJ PRIVATE _IRR_LINUX_X11_XINPUT2_)
endif()

if(USE_XCURSOR)
	target_compile_definitions(IRROTHEROBJ PRIVATE _IRR_LINUX_XCURSOR_)
endif()

add_library(IRRGUIOBJ OBJECT
	CGUIButton.h
	CGUICheckBox.h
	CGUIComboBox.h
	CGUIEditBox.h
	CGUIEnvironment.h
	CGUIFileOpenDialog.h
	CGUIFont.h
	CGUIImage.h
	CGUIListBox.h
	CGUIScrollBar.h
	CGUISkin.h
	CGUIStaticText.h
	CGUITabControl.h
	CGUISpriteBank.h
	CGUIImageList.h

	CGUIButton.cpp
	CGUICheckBox.cpp
	CGUIComboBox.cpp
	CGUIEditBox.cpp
	CGUIEnvironment.cpp
	CGUIFileOpenDialog.cpp
	CGUIFont.cpp
	CGUIImage.cpp
	CGUIListBox.cpp
	CGUIScrollBar.cpp
	CGUISkin.cpp
	CGUIStaticText.cpp
	CGUITabControl.cpp
	CGUISpriteBank.cpp
	CGUIImageList.cpp
)

# Library

file(GLOB_RECURSE IrrlichtMt_PUBLIC_HDRS "${CMAKE_CURRENT_SOURCE_DIR}/../include/*.h")

# There have to be some sources in IrrlichtMt to workaround Cmake Xcode generator bug
add_library(IrrlichtMt STATIC
	${IrrlichtMt_PUBLIC_HDRS}

	CBillboardSceneNode.h
	CCameraSceneNode.h
	CDummyTransformationSceneNode.h
	CEmptySceneNode.h
	CMeshManipulator.h
	CSceneCollisionManager.h
	CSceneManager.h
	CMeshCache.h

	CBillboardSceneNode.cpp
	CCameraSceneNode.cpp
	CDummyTransformationSceneNode.cpp
	CEmptySceneNode.cpp
	CMeshManipulator.cpp
	CSceneCollisionManager.cpp
	CSceneManager.cpp
	CMeshCache.cpp
)
foreach(object_lib
	IRRMESHOBJ IRRVIDEOOBJ
	IRRIOOBJ IRROTHEROBJ IRRGUIOBJ)
	# Set include directories for object library compilation
	target_include_directories(${object_lib} PRIVATE ${link_includes})
	if(CMAKE_GENERATOR STREQUAL "Xcode")

=== src/client/CMakeLists.txt ===
set(sound_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/sound.cpp)

if(USE_SOUND)
	list(APPEND sound_SRCS
		${CMAKE_CURRENT_SOURCE_DIR}/sound/al_extensions.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/sound/al_helpers.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/sound/ogg_file.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/sound/playing_sound.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/sound/proxy_sound_manager.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/sound/sound_data.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/sound/sound_manager.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/sound/sound_openal.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/sound/sound_singleton.cpp
	)
	set(SOUND_INCLUDE_DIRS
		${OPENAL_INCLUDE_DIR}
		${VORBIS_INCLUDE_DIR}
		${OGG_INCLUDE_DIR}
		PARENT_SCOPE)
	set(SOUND_LIBRARIES
		${OPENAL_LIBRARY}
		${VORBIS_LIBRARIES}
		PARENT_SCOPE)
endif()

file(GLOB_RECURSE client_HDRS "${CMAKE_CURRENT_SOURCE_DIR}/*.h")

set(client_SRCS
	${client_HDRS}
	${sound_SRCS}
	${CMAKE_CURRENT_SOURCE_DIR}/meshgen/collector.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/render/anaglyph.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/render/core.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/render/factory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/render/interlaced.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/render/plain.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/render/sidebyside.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/render/stereo.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/render/secondstage.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/render/pipeline.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/activeobjectmgr.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/camera.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/client.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/clientenvironment.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/clientlauncher.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/clientmap.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/clientmedia.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/clientobject.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/clouds.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/content_cao.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/content_cso.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/content_mapblock.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/filecache.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/fontengine.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/game.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/gameui.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/game_formspec.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/guiscalingfilter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/hud.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/imagefilters.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/inputhandler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/item_visuals_manager.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/joystick_controller.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/keycode.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/localplayer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/mapblock_mesh.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/mesh.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/mesh_generator_thread.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/minimap.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/particles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/renderingengine.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/shader.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/sky.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/tile.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/texturepaths.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/texturesource.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/imagesource.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/wieldmesh.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/shadows/dynamicshadows.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/shadows/dynamicshadowsrender.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/shadows/shadowsshadercallbacks.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/shadows/shadowsScreenQuad.cpp
	PARENT_SCOPE
)

=== src/server/CMakeLists.txt ===
file(GLOB common_server_HDRS "${CMAKE_CURRENT_SOURCE_DIR}/*.h")

set(common_server_SRCS
	${common_server_HDRS}
	${CMAKE_CURRENT_SOURCE_DIR}/activeobjectmgr.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/ban.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/blockmodifier.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/clientiface.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/luaentity_sao.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/mods.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/player_sao.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/rollback.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/serveractiveobject.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/serverinventorymgr.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/serverlist.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/unit_sao.cpp
	PARENT_SCOPE)

=== src/script/lua_api/CMakeLists.txt ===
file(GLOB common_SCRIPT_LUA_API_HDRS "${CMAKE_CURRENT_SOURCE_DIR}/*.h")

set(common_SCRIPT_LUA_API_SRCS
	${common_SCRIPT_LUA_API_HDRS}
	${CMAKE_CURRENT_SOURCE_DIR}/l_areastore.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_auth.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_base.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_craft.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_env.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_http.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_inventory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_ipc.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_item.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_itemstackmeta.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_mapgen.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_metadata.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_modchannels.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_nodemeta.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_nodetimer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_noise.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_object.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_particles.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_playermeta.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_rollback.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_server.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_settings.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_storage.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_util.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_vmanip.cpp
	PARENT_SCOPE)

set(client_SCRIPT_LUA_API_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/l_camera.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_client.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_client_common.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_client_sound.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_localplayer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_mainmenu.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_mainmenu_sound.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_menu_common.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_minimap.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_particles_local.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_pause_menu.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_storage.cpp
	PARENT_SCOPE)

=== debian/control ===
Source: luanti
Section: games
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Travis Wrightsman <travis@wrightsman.org>,
           Martin Quinson <mquinson@debian.org>,
           Markus Koschany <apo@debian.org>,
           Dominik George <natureshadow@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext,
               libcurl4-openssl-dev,
               libfreetype-dev,
               libgl-dev,
               libgmp-dev,
               libjpeg-dev,
               libjsoncpp-dev,
               libleveldb-dev,
               libluajit-5.1-dev,
               libogg-dev,
               libopenal-dev,
               libpng-dev,
               libpq-dev,
               libsdl2-dev,
               libspatialindex-dev,
               libsqlite3-dev,
               libvorbis-dev,
               libxi-dev,
               libzstd-dev,
               pkgconf,
               prometheus-cpp-dev,
               zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://www.luanti.org
Vcs-Git: https://salsa.debian.org/games-team/luanti.git
Vcs-Browser: https://salsa.debian.org/games-team/luanti
Rules-Requires-Root: no

Package: minetest
Depends: luanti, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 Minetest has been renamed to Luanti.
 This is a transitional package. It can safely be removed.

Package: luanti
Architecture: any
Replaces: minetest (<< 5.10.0+dfsg-1~)
Breaks: minetest (<< 5.10.0+dfsg-1~)
Depends: luanti-data (= ${source:Version}),
         sse2-support [i386],
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: luanti-game-minetest
Suggests: luanti-server,
          minetest-mod-moreblocks,
          minetest-mod-moreores,
          minetest-mod-pipeworks,
          minetestmapper
Description: Multiplayer infinite-world block sandbox
 Luanti is a Minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.

Package: minetest-server
Depends: luanti-server, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 Minetest has been renamed to Luanti.
 This is a transitional package. It can safely be removed.

Package: luanti-server
Architecture: any
Conflicts: minetest-server (<< 5.10.0+dfsg-1~)
Depends: luanti-data (= ${source:Version}),
         luanti-game-minetest,
         sse2-support [i386],
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Multiplayer infinite-world block sandbox (server)
 Luanti is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 This is the Luanti server package.

Package: minetest-data
Depends: luanti-data, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 Minetest has been renamed to Luanti.
 This is a transitional package. It can safely be removed.

Package: luanti-data
Architecture: all
Replaces: minetest-data (<< 5.10.0+dfsg-1~)
Breaks: minetest-data (<< 5.10.0+dfsg-1~)
Multi-Arch: foreign
Depends: fonts-croscore, fonts-droid-fallback, ${misc:Depends}
Description: Multiplayer infinite-world block sandbox (data files)
 Luanti is a Minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 These are the files used by both client and server packages, such as
 the textures and other graphical files and the standard mods.

## luanti 5.13.0+dfsg

=== lib/bitop/CMakeLists.txt ===
add_library(bitop STATIC bit.cpp bit.h)
target_include_directories(bitop PRIVATE ${LUA_INCLUDE_DIR})

set(LUA_BIT_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR} PARENT_SCOPE)
set(LUA_BIT_LIBRARY bitop PARENT_SCOPE)

=== src/database/CMakeLists.txt ===
file(GLOB database_HDRS "${CMAKE_CURRENT_SOURCE_DIR}/*.h")

set(database_SRCS
	${database_HDRS}
	${CMAKE_CURRENT_SOURCE_DIR}/database.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/database-dummy.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/database-files.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/database-leveldb.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/database-postgresql.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/database-redis.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/database-sqlite3.cpp
	PARENT_SCOPE
)

=== src/unittest/CMakeLists.txt ===
file(GLOB unittest_HDRS "${CMAKE_CURRENT_SOURCE_DIR}/*.h")

set (UNITTEST_SRCS
	${unittest_HDRS}
	${CMAKE_CURRENT_SOURCE_DIR}/test.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_address.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_authdatabase.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_activeobject.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_areastore.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_ban.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_collision.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_compression.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_connection.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_craft.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_datastructures.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_k_d_tree.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_filesys.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_inventory.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_irrptr.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_irr_matrix4.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_irr_rotation.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_logging.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_lbmmanager.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_lua.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_map.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_mapblock.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_mapdatabase.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_mapgen.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_map_settings_manager.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_mapnode.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_modchannels.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_modstoragedatabase.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_moveaction.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_nodedef.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_noderesolver.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_noise.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_objdef.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_profiler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_random.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_sao.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_schematic.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_scriptapi.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_serialization.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_serveractiveobjectmgr.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_server_shutdown_state.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_settings.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_socket.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_servermodmanager.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_threading.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_translations.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_utilities.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_voxelarea.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_voxelalgorithms.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_voxelmanipulator.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_gettext.cpp
	PARENT_SCOPE)

set (UNITTEST_CLIENT_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/mesh_compare.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_clientactiveobjectmgr.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_content_mapblock.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_eventmanager.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_gameui.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_irr_gltf_mesh_loader.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_irr_x_mesh_loader.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_irr_matrix4.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_mesh_compare.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/test_keycode.cpp
	PARENT_SCOPE)

=== debian/changelog ===
luanti (5.13.0+dfsg-0.1~mx25+1) mx; urgency=medium

  * New upstream release.
  * Remove d/patches; applied in the new releases.
  * Add libsdl2-dev to BDs to fix FTBFS.
  * Disable all tests on armhf as they fail.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 15 Sep 2025 14:27:57 -0700

=== debian/rules ===
#!/usr/bin/make -f

# build-hardening flags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# ignore Lua destructor test failures on archs where it doesn't pass
ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH),armel armhf loong64 mips64el))
	export LUANTI_CMAKE_TEST_FLAGS = -DIGNORE_LUA_DESTRUCTOR_TEST_FAILURE=TRUE
endif

override_dh_auto_configure:
	dh_auto_configure -- \
		-DRUN_IN_PLACE=0 \
		-DBUILD_DOCUMENTATION=FALSE \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DENABLE_SYSTEM_JSONCPP=1 \
		-DENABLE_SYSTEM_GMP=1 \
		-DENABLE_SPATIAL=ON \
		-DJSON_INCLUDE_DIR=/usr/include/jsoncpp \
		-DENABLE_GETTEXT=1 \
		-DFREETYPE_INCLUDE_DIR_freetype2=/usr/include/freetype2 \
		-DFREETYPE_INCLUDE_DIR_ft2build=/usr/include \
		-DENABLE_LEVELDB=1 \
		-DENABLE_POSTGRESQL=1 \
		-DLEVELDB_INCLUDE_DIR=/usr/include/leveldb \
		-DCUSTOM_LOCALEDIR=/usr/share/locale \
		-DCUSTOM_SHAREDIR=/usr/share/luanti \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DBUILD_SERVER=1 \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DENABLE_UPDATE_CHECKER=OFF \
		-DREQUIRE_LUAJIT=TRUE \
		-DINSTALL_DEVTEST=TRUE \
		-DENABLE_PROMETHEUS=TRUE \
		${LUANTI_CMAKE_TEST_FLAGS}

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_auto_test:
	HOME=$$(mktemp -d) bin/luanti --run-unittests
	dh_auto_test

override_dh_auto_test:
ifneq (,$(filter $(DEB_HOST_ARCH), armhf))
	# no tests
else
	HOME=$$(mktemp -d) bin/luanti --run-unittests
	dh_auto_test
endif

override_dh_auto_install:
	install -D -m 444 $(CURDIR)/doc/luanti.6 $(CURDIR)/debian/luanti-server/usr/share/man/man6/luantiserver.6
	dh_auto_install

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

%:
	dh ${@}

## luanti 5.14.0+dfsg

=== debian/changelog ===
luanti (5.14.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Remove /var/(lib|log)/private/luanti on purge. (Closes: #1122677)
  * Don't log to file by default, use journald. (Closes: #1125461)
  * As we are logging to journald, logrotate is no longer needed.

 -- Tobias Frost <tobi@debian.org>  Sun, 15 Feb 2026 12:57:32 +0100

luanti (5.14.0+dfsg-2) unstable; urgency=medium

  * Team upload
  * Enable loong64

 -- Bastian Germann <bage@debian.org>  Wed, 21 Jan 2026 23:16:41 +0100

luanti (5.14.0+dfsg-1) unstable; urgency=medium

  * New upstream version 5.14.0+dfsg
    (Closes: #1102042, #1119258)
  * Remove i386 from builds
    * Core unit test is failing but unable to fix so far
  * Remove transitional packages
  * Drop patches applied upstream
  * Refresh test skip patch
  * Remove minetest/minetestserver migration aliases
  * Add patch to fix AppStream metadata

 -- Travis Wrightsman <travis@wrightsman.org>  Sun, 05 Oct 2025 21:19:35 +0200

=== debian/control ===
Source: luanti
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Travis Wrightsman <travis@wrightsman.org>,
 Martin Quinson <mquinson@debian.org>,
 Markus Koschany <apo@debian.org>,
 Dominik George <natureshadow@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 gettext,
 libcurl4-openssl-dev,
 libfreetype-dev,
 libgl-dev,
 libgmp-dev,
 libjpeg-dev,
 libjsoncpp-dev,
 libleveldb-dev,
 libluajit-5.1-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libpq-dev,
 libsdl2-dev,
 libspatialindex-dev,
 libsqlite3-dev,
 libvorbis-dev,
 libxi-dev,
 pkgconf,
 zlib1g-dev,
 libzstd-dev,
 prometheus-cpp-dev
Standards-Version: 4.7.2
Homepage: https://www.luanti.org
Vcs-Git: https://salsa.debian.org/games-team/luanti.git
Vcs-Browser: https://salsa.debian.org/games-team/luanti
Rules-Requires-Root: no

Package: luanti
Architecture: amd64 arm64 armhf loong64 ppc64el riscv64 s390x
Depends:
 luanti-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 luanti-game-minetest
Suggests:
 luanti-server,
 minetestmapper
Description: Multiplayer infinite-world block sandbox
 Luanti is a Minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.

Package: luanti-server
Architecture: amd64 arm64 armhf loong64 ppc64el riscv64 s390x
Depends:
 luanti-data (= ${source:Version}),
 luanti-game-minetest,
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends:
 ${misc:Pre-Depends}
Description: Multiplayer infinite-world block sandbox (server)
 Luanti is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 This is the Luanti server package.

Package: luanti-data
Architecture: all
Multi-Arch: foreign
Depends:
 fonts-croscore,
 fonts-droid-fallback,
 ${misc:Depends}
Description: Multiplayer infinite-world block sandbox (data files)
 Luanti is a Minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 These are the files used by both client and server packages, such as
 the textures and other graphical files and the standard mods.
